/*
 * ansi.c:
 *
 * Copyright (c) 2008 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] = "$Id$";

/*
 * $Log$
 * Revision 1.28  2008/02/22 17:07:00  james
 * *** empty log message ***
 *
 * Revision 1.27  2008/02/20 22:54:22  staffcvs
 * *** empty log message ***
 *
 * Revision 1.26  2008/02/20 20:16:07  james
 * *** empty log message ***
 *
 * Revision 1.25  2008/02/20 19:44:37  james
 * @@
 *
 * Revision 1.24  2008/02/20 19:36:06  james
 * @@
 *
 * Revision 1.23  2008/02/20 19:25:09  james
 * *** empty log message ***
 *
 * Revision 1.22  2008/02/15 03:32:07  james
 * *** empty log message ***
 *
 * Revision 1.21  2008/02/14 02:46:44  james
 * *** empty log message ***
 *
 * Revision 1.20  2008/02/14 01:55:57  james
 * *** empty log message ***
 *
 * Revision 1.19  2008/02/13 16:57:29  james
 * *** empty log message ***
 *
 * Revision 1.18  2008/02/13 09:12:21  james
 * *** empty log message ***
 *
 * Revision 1.17  2008/02/13 01:08:18  james
 * *** empty log message ***
 *
 * Revision 1.16  2008/02/07 13:22:51  james
 * *** empty log message ***
 *
 * Revision 1.15  2008/02/07 13:19:48  james
 * *** empty log message ***
 *
 * Revision 1.14  2008/02/07 12:21:16  james
 * *** empty log message ***
 *
 * Revision 1.13  2008/02/07 12:16:04  james
 * *** empty log message ***
 *
 * Revision 1.12  2008/02/07 11:32:41  james
 * *** empty log message ***
 *
 * Revision 1.11  2008/02/07 11:11:14  staffcvs
 * *** empty log message ***
 *
 * Revision 1.10  2008/02/07 01:02:52  james
 * *** empty log message ***
 *
 * Revision 1.9  2008/02/07 00:43:27  james
 * *** empty log message ***
 *
 * Revision 1.8  2008/02/07 00:39:13  james
 * *** empty log message ***
 *
 * Revision 1.7  2008/02/06 20:26:57  james
 * *** empty log message ***
 *
 * Revision 1.6  2008/02/06 17:53:28  james
 * *** empty log message ***
 *
 * Revision 1.5  2008/02/06 15:53:22  james
 * *** empty log message ***
 *
 * Revision 1.4  2008/02/04 20:23:55  james
 * *** empty log message ***
 *
 * Revision 1.3  2008/02/04 05:45:55  james
 * ::
 *
 * Revision 1.2  2008/02/04 02:05:06  james
 * *** empty log message ***
 *
 * Revision 1.1  2008/02/03 23:31:25  james
 * *** empty log message ***
 *
 */
#include "project.h"


static void
ansi_move (ANSI * a, CRT_Pos p)
{
  char buf[16];
  int n;
  int dx = p.x - a->pos.x;
  int dy = p.y - a->pos.y;

//  a->pos.x = ANSI_INVAL;

  if (a->pos.x != ANSI_INVAL)
    {

      if ((!dx) && (!dy))
        return;

      if (!dy)
        {
          if (dx == 1)
            {
              a->terminal->xmit (a->terminal, "\033[C", 3);
            }
          else if (dx == -1)
            {
              a->terminal->xmit (a->terminal, "\033[D", 3);
            }
          else
            {
              n = snprintf (buf, sizeof (buf), "\033[%dG", p.x + 1);
              a->terminal->xmit (a->terminal, buf, n);
            }
        }
      else if (!dx)
        {
          if (dy == -1)
            {
              a->terminal->xmit (a->terminal, "\033[A", 3);
            }
          else if (dy == 1)
            {
              a->terminal->xmit (a->terminal, "\033[B", 3);
            }
          else if (dy < 0)
            {
              n = snprintf (buf, sizeof (buf), "\033[%dA", -dy);
              a->terminal->xmit (a->terminal, buf, n);
            }
          else
            {
              n = snprintf (buf, sizeof (buf), "\033[%dB", dy);
              a->terminal->xmit (a->terminal, buf, n);
            }
        }
      else if (!p.x)
        {
          if (dy == 1)
            {
              a->terminal->xmit (a->terminal, "\033[E", 3);
            }
          else if (dy == -1)
            {
              a->terminal->xmit (a->terminal, "\033[F", 3);
            }
          else if (dy > 0)
            {
              n = snprintf (buf, sizeof (buf), "\033[%dE", dy);
              a->terminal->xmit (a->terminal, buf, n);
            }
          else
            {
              n = snprintf (buf, sizeof (buf), "\033[%dF", -dy);
              a->terminal->xmit (a->terminal, buf, n);
            }
        }
      else
        {
          n = snprintf (buf, sizeof (buf), "\033[%d;%dH", p.y + 1, p.x + 1);
          a->terminal->xmit (a->terminal, buf, n);
        }
    }
  else
    {
      n = snprintf (buf, sizeof (buf), "\033[%d;%dH", p.y + 1, p.x + 1);
      a->terminal->xmit (a->terminal, buf, n);
    }

  a->pos = p;
}


static void
ansi_showhide_cursor (ANSI * a, int hide)
{
  if (a->hide_cursor == hide)
    return;

  if (hide)
    {
      a->terminal->xmit (a->terminal, "\033[?25l", 6);
    }
  else
    {
      a->terminal->xmit (a->terminal, "\033[?25h", 6);
    }

  a->hide_cursor = hide;
}


static void
ansi_force_attr_normal (ANSI * a)
{
  a->terminal->xmit (a->terminal, "\033[0m", 4);
  a->attr = CRT_ATTR_NORMAL;
  a->color = ANSI_INVAL;
}

static void
ansi_set_color (ANSI * a, int color)
{
  int dif;
  char buf[16];
  int i;
  int fg, bg;

  if ((a->color == ANSI_INVAL) || (color != a->color))
    {
      fg = CRT_COLOR_FG (color);
      bg = CRT_COLOR_BG (color);

      if (fg & CRT_COLOR_INTENSITY)
        {
          fg += 90;
        }
      else
        {
          fg += 30;
        }

      if (bg & CRT_COLOR_INTENSITY)
        {
          bg += 100;
        }
      else
        {
          bg += 40;
        }

      i = sprintf (buf, "\033[%d;%dm", fg, bg);
#if 0
      fprintf (stderr, "Color set to %d %d %x\n", fg, bg, color);
#endif

      a->terminal->xmit (a->terminal, buf, i);
      a->color = color;
    }
}

static void
ansi_set_attr (ANSI * a, int attr)
{
  int dif;

  dif = attr ^ a->attr;

  if (!dif)
    return;

  a->attr = attr;

#if 0
  if (attr == CRT_ATTR_NORMAL)
    {
      ansi_force_attr_normal (a);
      return;
    }
#endif

  if (dif & CRT_ATTR_UNDERLINE)
    {
      if (attr & CRT_ATTR_UNDERLINE)
        {
          a->terminal->xmit (a->terminal, "\033[4m", 4);
        }
      else
        {
          a->terminal->xmit (a->terminal, "\033[24m", 5);
        }
    }
  if (dif & CRT_ATTR_REVERSE)
    {
      if (attr & CRT_ATTR_REVERSE)
        {
          a->terminal->xmit (a->terminal, "\033[7m", 4);
        }
      else
        {
          a->terminal->xmit (a->terminal, "\033[27m", 5);
        }
    }
  if (dif & CRT_ATTR_BOLD)
    {
      if (attr & CRT_ATTR_BOLD)
        {
          a->terminal->xmit (a->terminal, "\033[1m", 4);
        }
      else
        {
          a->terminal->xmit (a->terminal, "\033[21m", 5);
          a->terminal->xmit (a->terminal, "\033[22m", 5);
        }
    }

}


static void
ansi_render (ANSI * a, CRT_CA ca)
{
  int dif;

  if (ca.chr < 32)
    ca.chr = ' ';
  if (ca.chr > 126)
    ca.chr = ' ';

  ansi_set_attr (a, ca.attr);
  ansi_set_color (a, ca.color);

  a->terminal->xmit (a->terminal, &ca.chr, 1);

  a->pos.x++;

/*Can't easily wrap round here as don't know size of destination screen*/
/*so invalidate the cached cursor position*/

  if (a->pos.x >= a->size.x)
    a->pos.x = ANSI_INVAL;

}

static void
ansi_cls (ANSI * a)
{
  CRT_Pos p = { 0 };

  crt_cls (&a->crt);

  ansi_set_attr (a, CRT_ATTR_NORMAL);
  ansi_set_color (a, CRT_COLOR_NORMAL);
  ansi_move (a, p);
  a->terminal->xmit (a->terminal, "\033[2J", 4);
/*different emulators leave cursor in different places after cls differently*/
  a->pos.x = ANSI_INVAL;
}

#if 0
int
ansi_scroll_up (ANSI * a, CRT_Pos s, CRT_Pos e)
{
  char buf[16];
  int i;
  if (s.x)
    return -1;
  if (e.x != (CRT_COLS - 1))
    return -1;
  if (s.y)
    return -1;
  if (s.y >= a->size.y)
    return -1;

  ansi_showhide_cursor (a, 1);
  i = sprintf (buf, "\033[%d;%dr", s.y + 1, e.y + 1);
  a->terminal->xmit (a->terminal, buf, i);
  i = sprintf (buf, "\033[%d;%dH", e.y + 1, 0);
  a->terminal->xmit (a->terminal, buf, i);
  a->terminal->xmit (a->terminal, "\033D", 2);
  a->terminal->xmit (a->terminal, "\033[r", 3);

  s.y = e.y;
  crt_erase (&a->crt, s, e, 1);

  a->pos.x = ANSI_INVAL;

  return 0;
}


static void
ansi_spot_scroll_up (ANSI * a, CRT * c)
{
  int l, n, p;

  l = c->sh.e.x - c->sh.s.x;
  l++;
  l *= sizeof (CRT_CA);

  n = c->sh.e.y - c->sh.s.y;
  p = CRT_ADDR_POS (&c->sh.s);

  while (n--)
    {
      if (memcmp (&c->screen[p], &a->crt.screen[p + CRT_COLS], l))
        return;
      p += CRT_COLS;
    }

  if (ansi_scroll_up (a, c->sh.s, c->sh.e))
    return;

  n = c->sh.e.y - c->sh.s.y;
  p = CRT_ADDR_POS (&c->sh.s);

  while (n--)
    {
      memcpy (&a->crt.screen[p], &a->crt.screen[p + CRT_COLS], l);
      p += CRT_COLS;
    }

  c->sh.dir = 0;                //FIXME: horrid hack

}

static void
ansi_spot_scroll (ANSI * a, CRT * c)
{

  switch (c->sh.dir)
    {
    case -1:
/*we only care about up for the moment */
      ansi_spot_scroll_up (a, c);
      break;
    }

  return;
}

#endif


static void
ansi_draw_line (ANSI * a, CRT_CA * cap, int y)
{
  CRT_Pos p = { 0, y };
  CRT_CA *acap = &a->crt.screen[CRT_ADDR_POS (&p)];

  for (p.x = 0; p.x < CRT_COLS; ++p.x)
    {
      if (p.x >= a->size.x)
        continue;

      if (crt_ca_cmp (*acap, *cap))
        {
          ansi_showhide_cursor (a, 1);
          *acap = *cap;

          ansi_move (a, p);
          ansi_render (a, *acap);
        }

      acap++;
      cap++;
    }
}

static void
ansi_resize_check (ANSI * a)
{

  if (!crt_pos_cmp (a->terminal->size, a->size))
    return;

  terminal_getsize (a->terminal);

  a->size = a->terminal->size;

  a->pos.x = ANSI_INVAL;
  a->hide_cursor = ANSI_INVAL;

  crt_reset (&a->crt);

// FIXME: -- echos back crap?
//  a->terminal->xmit (a->terminal, "\033[c", 3);

  ansi_cls (a);
  a->terminal->xmit (a->terminal, "\033=", 2);
  a->terminal->xmit (a->terminal, "\033[?6l", 5);
  a->terminal->xmit (a->terminal, "\033[r", 3);

}

#define HISTORY_GUESS_SCROLL 24 /*guess all 24 lines usually scroll */
/*if they haven't then ansi_draw will patch it up*/

static void
ansi_history (ANSI * a, History * h)
{
  char buf[32];
  int i;
/*Do we need to catch up on history?*/

  if (a->history_ptr == h->wptr)
    return;
  ansi_resize_check (a);

  if ((a->size.x < CRT_COLS) || (a->size.y < CRT_ROWS))
    return;

  ansi_force_attr_normal (a);
  ansi_set_color (a, CRT_COLOR_NORMAL);

  i = sprintf (buf, "\033[%d;%dr", 1, HISTORY_GUESS_SCROLL);
  a->terminal->xmit (a->terminal, buf, i);


  while (a->history_ptr != h->wptr)
    {

      History_ent *e = &h->lines[a->history_ptr];

      HISTORY_INC (h, a->history_ptr);

      if (!e->valid)
        continue;

      /*If so write the line ot the top of the screen */
      ansi_draw_line (a, e->line, 0);


      /*Roll HISTORY_GUESS_SCROLL lines up putting the top line into the xterm's history */


      /*Make extra lines a predictable colour*/
      ansi_set_color (a, CRT_COLOR_NORMAL);

      ansi_showhide_cursor (a, 1);
      i = sprintf (buf, "\033[%d;%dH", HISTORY_GUESS_SCROLL, 1);
      a->terminal->xmit (a->terminal, buf, i);
      a->terminal->xmit (a->terminal, "\033D", 2);
      a->pos.x = ANSI_INVAL;

      /*now do the same in our image of the screen */

      {
        CRT_Pos s = { 0 }
        , e =
        {
        0};

        /*scroll lines up */
        for (s.y++; s.y < HISTORY_GUESS_SCROLL; s.y++, e.y++)
          {
            memcpy (&a->crt.screen[CRT_ADDR_POS (&e)],
                    &a->crt.screen[CRT_ADDR_POS (&s)],
                    sizeof (CRT_CA) * CRT_COLS);
          }

        /* erase new line */
        s.y = e.y;
        e.x = CRT_COLS - 1;
        crt_erase (&a->crt, s, e, 1,CRT_COLOR_NORMAL);
      }

    }
/*reset margins*/
  a->terminal->xmit (a->terminal, "\033[r", 3);
  a->pos.x = ANSI_INVAL;

}




static void
ansi_draw (ANSI * a, CRT * c)
{
  CRT_Pos p;
  int o;
  int hidden_cursor = 0;

  ansi_resize_check (a);



  for (p.y = 0; p.y < CRT_ROWS; ++p.y)
    {
      if (p.y >= a->size.y)
        continue;

      ansi_draw_line (a, &c->screen[CRT_ADDR (p.y, 0)], p.y);

    }


  if ((CRT_COLS > a->size.x) || (CRT_ROWS > a->size.y))
    {
      char msg[1024];           // = "Window is too small";
      int i;
      p.x = 0;
      p.y = 0;

      i =
        sprintf (msg, "Window too small (%dx%d need %dx%d)", a->size.x,
                 a->size.y, CRT_COLS, CRT_ROWS);

      ansi_showhide_cursor (a, 1);
      ansi_set_attr (a, CRT_ATTR_REVERSE);
      ansi_set_color (a, CRT_MAKE_COLOR (CRT_COLOR_WHITE, CRT_COLOR_RED));
      ansi_move (a, p);

      a->terminal->xmit (a->terminal, msg, i);
      a->pos.x = ANSI_INVAL;
    }


  if ((c->pos.x >= a->size.x) || (c->pos.y >= a->size.y))
    {
      ansi_showhide_cursor (a, 1);
      return;
    }

  a->crt.pos = c->pos;
  ansi_move (a, a->crt.pos);

  a->crt.hide_cursor = c->hide_cursor;
  ansi_showhide_cursor (a, a->crt.hide_cursor);
}

static void
ansi_reset (ANSI * a, CRT * c)
{
  a->size.x = -1;
  ansi_draw (a, c ? c : &a->crt);
}

static void
ansi_terminal_reset (ANSI * a)
{
  CRT_Pos p = { 0, CRT_ROWS };
  ansi_force_attr_normal (a);

  ansi_move (a, p);
}

static void
ansi_flush_escape (ANSI * a, Context * c)
{
  ANSI_Parser *p = &a->parser;
  int i;

  for (i = 0; i < p->escape_ptr; ++i)
    {
      keydis_key (c->k, c, p->escape_buf[i]);
    }

  p->escape_ptr = 0;
  p->in_escape = 0;
}

static void
ansi_parse_deckey (ANSI * a, Context * c)
{
  ANSI_Parser *p = &a->parser;
  if ((p->escape_buf[1] != '[') && (p->escape_buf[1] != 'O'))
    {
      ansi_flush_escape (a, c);
      return;
    }

  if ((p->escape_buf[2] >= 'A') || (p->escape_buf[2] <= 'Z'))
    {
      keydis_key (c->k, c, KEY_UP + (p->escape_buf[2] - 'A'));
    }
  else if ((p->escape_buf[2] >= 'a') || (p->escape_buf[2] <= 'z'))
    {
      keydis_key (c->k, c, KEY_154 + (p->escape_buf[2] - 'a'));
    }
  else
    {
      ansi_flush_escape (a, c);
      return;
    }
  p->in_escape = 0;
  p->escape_ptr = 0;
}

static void
ansi_parse_ansikey (ANSI * a, Context * c)
{
  ANSI_Parser *p = &a->parser;

  if ((p->escape_buf[1] != '[') || (p->escape_buf[3] != '~'))
    {
      ansi_flush_escape (a, c);
      return;
    }
  if ((p->escape_buf[2] >= '0') || (p->escape_buf[2] <= '9'))
    {
      keydis_key (c->k, c, KEY_180 + (p->escape_buf[2] - '0'));
    }
  else
    {
      ansi_flush_escape (a, c);
      return;
    }

  p->in_escape = 0;
  p->escape_ptr = 0;
}



static void
ansi_parse_escape (ANSI * a, Context * c)
{
  ANSI_Parser *p = &a->parser;
  switch (p->escape_ptr)
    {
    case 0:
    case 1:
      return;
    case 2:
      switch (p->escape_buf[1])
        {
        case '[':
        case 'O':
          break;
        default:
          ansi_flush_escape (a, c);
        }
      break;
    case 3:
      switch (p->escape_buf[1])
        {
        case 'O':
          ansi_parse_deckey (a, c);
          break;
        case '[':
          if ((p->escape_buf[2] >= 'A') && (p->escape_buf[2] <= 'Z'))
            ansi_parse_deckey (a, c);
          break;
        default:
          ansi_flush_escape (a, c);
        }
      break;
    case 4:
      switch (p->escape_buf[1])
        {
        case '[':
          ansi_parse_ansikey (a, c);
          break;
        default:
          ansi_flush_escape (a, c);
        }
      break;
    case 5:
      ansi_flush_escape (a, c);
    }
}


static void
ansi_check_escape (ANSI * a, Context * c)
{
  ANSI_Parser *p = &a->parser;
  struct timeval now, diff;
  gettimeofday (&now, NULL);
  timersub (&now, &p->last_escape, &diff);

#if 0
  fprintf (stderr, "ie %d tl %d.%06d eb %d\n",
           p->in_escape, diff.tv_sec, diff.tv_usec, p->escape_ptr);
#endif

  if (!p->in_escape)
    return;


  /*Time up? */
  if (diff.tv_sec || (diff.tv_usec > ANSI_ESCAPE_TIMEOUT))
    ansi_flush_escape (a, c);

}


static void
ansi_parse_char (ANSI * a, Context * c, int ch)
{
  ANSI_Parser *p = &a->parser;


/*See if it's time to flush the escape*/
  ansi_check_escape (a, c);

  if (ch == 033)
    {
      if (p->in_escape)
        ansi_flush_escape (a, c);

      p->in_escape++;
      p->escape_ptr = 0;
      gettimeofday (&p->last_escape, NULL);
    }

  if (p->in_escape)
    {
      p->escape_buf[p->escape_ptr++] = ch;
      ansi_parse_escape (a, c);
    }
  else
    {
      keydis_key (c->k, c, ch);
    }

}

static void
ansi_parse (ANSI * a, Context * c, char *buf, int len)
{
  while (len--)
    ansi_parse_char (a, c, *(buf++));
}

int
ansi_dispatch (ANSI * a, Context * c)
{
  char buf[1024];
  int red;

  ansi_check_escape (a, c);


  if (!a->terminal)
    return 0;

  red = a->terminal->recv (a->terminal, buf, sizeof (buf));
  if (red <= 0)
    return red;

#if 0
  if (*buf == 3)
    return -1;
#endif

#if 0
  if (*buf == 2)
    {
#if  0
      a->history_ptr = c->h->wptr;
      HISTORY_INC (c->h, a->history_ptr);
#endif
      return -1;
    }
#endif


  ansi_parse (a, c, buf, red);

  return 0;
}


static void
ansi_update (ANSI * a, Context * c)
{
  ansi_history (a, c->h);
  ansi_draw (a, &c->v->crt);
}

static void
ansi_free (ANSI * a)
{
  a->terminal_reset (a);
  if (a->terminal)
    a->terminal->close (a->terminal);

  free (a);

}

ANSI *
ansi_new_from_terminal (TTY * t)
{
  ANSI *ret;

  ret = malloc (sizeof (ANSI));
  memset (ret, 0, sizeof (ANSI));

  ret->terminal = t;

  ret->update = ansi_update;
  ret->reset = ansi_reset;
  ret->terminal_reset = ansi_terminal_reset;
  ret->close = ansi_free;
  ret->dispatch = ansi_dispatch;

  return ret;
}
